# coding: utf-8

"""
    ENBISYS AVM API

    API for ENBISYS AVM-platform  # noqa: E501

    OpenAPI spec version: 1.0.1
    Contact: avm@enbisys.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from enbisysavm.api_client import ApiClient


class ValuationApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_fast_valuation(self, property_features, **kwargs):  # noqa: E501
        """get_fast_valuation  # noqa: E501

        Get only property price valuation without confidence estimation.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fast_valuation(property_features, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PropertyFeatures property_features: Property features that describe property. (required)
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_fast_valuation_with_http_info(property_features, **kwargs)  # noqa: E501
        else:
            (data) = self.get_fast_valuation_with_http_info(property_features, **kwargs)  # noqa: E501
            return data

    def get_fast_valuation_with_http_info(self, property_features, **kwargs):  # noqa: E501
        """get_fast_valuation  # noqa: E501

        Get only property price valuation without confidence estimation.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fast_valuation_with_http_info(property_features, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PropertyFeatures property_features: Property features that describe property. (required)
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['property_features']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fast_valuation" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'property_features' is set
        if ('property_features' not in local_var_params or
                local_var_params['property_features'] is None):
            raise ValueError("Missing the required parameter `property_features` when calling `get_fast_valuation`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'property_features' in local_var_params:
            body_params = local_var_params['property_features']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/problem+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['ApiKeyAuth']  # noqa: E501

        return self.api_client.call_api(
            '/valuation/price', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='int',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_valuation(self, property_features, **kwargs):  # noqa: E501
        """get_valuation  # noqa: E501

        Get property price valuation with confidence estimation.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_valuation(property_features, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PropertyFeatures property_features: Property features to valuate. (required)
        :return: Valuation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_valuation_with_http_info(property_features, **kwargs)  # noqa: E501
        else:
            (data) = self.get_valuation_with_http_info(property_features, **kwargs)  # noqa: E501
            return data

    def get_valuation_with_http_info(self, property_features, **kwargs):  # noqa: E501
        """get_valuation  # noqa: E501

        Get property price valuation with confidence estimation.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_valuation_with_http_info(property_features, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PropertyFeatures property_features: Property features to valuate. (required)
        :return: Valuation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['property_features']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_valuation" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'property_features' is set
        if ('property_features' not in local_var_params or
                local_var_params['property_features'] is None):
            raise ValueError("Missing the required parameter `property_features` when calling `get_valuation`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'property_features' in local_var_params:
            body_params = local_var_params['property_features']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/problem+json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['ApiKeyAuth']  # noqa: E501

        return self.api_client.call_api(
            '/valuation/estimation', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Valuation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
